"""
Simple Python Port Scanner:
	#1: Import Libraries
	#2: Implement Arguments with argparse
	#3: Define Targets
	#3: Test sockets with the socket library
	#4: Add Banner Grabbing Capabilities
	#5: Write Report on Findings
"""

import socket
import argparse

def extractTargets(hostFile):
	# Define hostnameList and ipList variables as lists
	hostnameList = []
	ipList = []
	
	# Open File
	targetFileObj = open(hostFile,'r')
	
	# Parse each line, add hostnames to hostnameList
	targetFileContent = targetFileObj.readlines()
	
	for line in targetFileContent:
		hostnameList.append(line)
		
	# Convert hostnames to IP addresses, add ips to ipList
	for name in hostnameList:
		print "Attempting to resolve: "+name
		ipAddr = socket.gethostbyname(name.rstrip())
		print ipAddr
		ipList.append(ipAddr)
		
	# Close File
	targetFileObj.close()
	
	# Return list of IP addresses
	return ipList
	
def synScan(target,port):
	#Define portStatus variable to hold condition of a port
	portStatus = False
	
	#Define incomingData variable to hold data received from open port
	incomingData = ''
	
	# Create Socket
	socketObj = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	try:
		# Connect to destination
		socketObj.connect((target,port))
		portStatus = True
	except:
		pass
		
	# If connection succeeds, send data to attempt identifying the service 
	if portStatus:
		try:
			print "Made it to sending data"
			socketObj.sendall('Scan Test\r\n')
			incomingData = socketObj.recv(1024)
			print incomingData
		except:
			pass
	
	# Close connection
	socketObj.close()
	
	# Return True or False and data based on port state
	if portStatus:
		return (portStatus,target,port,incomingData)
	else:
		return (portStatus,target,port,"")
	
	
def main(reportFile,hostFile):
	# This is where the main execution of the script resides.
	#Define ports to scan
	portList = [80,443,8888]
	
	#Define portOpenedList
	portOpenedList = []
	
	#Define portClosedList
	portClosedList = []
	
	# Create file to write output (results) to.
	portScanReport = open(reportFile,'w+')
	
	# extractTargets(file)
	targetList = extractTargets(hostFile)
	
	# For each target, conduct synScan with each port
	for target in targetList:
		for port in portList:
			result = synScan(target,port)
			# Add successful connections and data to portOpenedList
			if result[0]:
				portOpenedList.append(result)
			# Add unsuccessful connections to portClosedList
			else:
				portClosedList.append(result)
	
	print portOpenedList
	print "Closed ports: "+str(portClosedList)
	# Write column header to file
	portScanReport.write("IP Address:\tPort:\tData:\n")
	
	# Write data from portOpenedList to file
	for entry in portOpenedList:
		portScanReport.write(entry[1]+"\t"+str(entry[2])+"\t"+entry[3]+"\n")
	
	# Close file
	portScanReport.close()
	
#argparse options
parser = argparse.ArgumentParser(description='Python Simple Port Scanner')
parser.add_argument('HOSTFILE', help='Host file to load for scanning.')
parser.add_argument('REPORTFILE', help='Report file to write results to.')
args = parser.parse_args()

if __name__ == '__main__':
	print args
	main(args.REPORTFILE, args.HOSTFILE)


